import 'dart:async';

Map<String, Timer> _timers = {};

void debounce(String tag, Duration duration, void Function() onExecute) {
  if (duration == Duration.zero) {
    _timers[tag]?.cancel();
    _timers.remove(tag);
    onExecute();
  } else {
    _timers[tag]?.cancel();

    _timers[tag] = Timer(duration, () {
      _timers[tag]?.cancel();
      _timers.remove(tag);

      onExecute();
    });
  }
}
